import KNode
import hashlib
from KNode import *
import shell
from connect import push
from Crypto.Cipher import PKCS1_v1_5
from Crypto.Hash import SHA
from Crypto.PublicKey import RSA
 
## RSA KEYS FOR TESTING:

pub_s = '0\x82\x01"0\r\x06\t*\x86H\x86\xf7\r\x01\x01\x01\x05\x00\x03\x82\x01\x0f\x000\x82\x01\n\x02\x82\x01\x01\x00\xb85\xa4\x92\xbeV\xa9?\xfe\xf8\xbb\xcfm9\x86\x1f\xe5\x90k\xb1(\xce\x01\xd0\x83u|p\x88\x13\x8f\x98\xc3\xf4\x11\xe1\xe4+\xdb.|\x06T\x16\x9c\x19#\xe5\x8a\xcd\x92\xcf\x0c\x0eO\x80f]\xc6\xa8\r{\xd9\x1d,x\xa9\xf0\x87\xe6\xceo\xfdl,\x1c\xcay2\xdcgab\x0c\x8a\'\x11#\x8dB\x9e)\xd0\xa3\xe5`>T\xd5\xd9\x97\x846F\x02yFl\xe7\x12\x92\x91\xa7\x14Q\x18\xb5gp\x1bU\xd7B#\xf1KY\xc0\xb8V\xd5k\xe7fg\xe0\xf3\xb4\x97E^\x03\xaa\xdf8kJ0\xd2\xbe\xa0\x94x\xc0\xb9\xa5\xe3\xa4\x06z\xd5\xe6\'\x0b\xe0\xd5,\x81\xc2-9\x846\xef\x85?\xc1\xcfU\x1f\xfb\x05\xda\xbb\x03\x82p\xd8\x81\xe0T\xfe\xe8\xc3\xe1=A\xce\xd7\x8fC\xa9\xdc\xcf\xa4\xe2\xf6Q\xd2\x1f\x89\x9aK\xdc\xa5F\xa7C\x10\xef\x12\xd7\xde\xb2=\xa1+\xda\x98*N\x071\xdf\xbe\xcd\xa1\xdc\xc0\xd7\x08x\xe9\x02\xcf\xfc#\x8f\x80\xd4hY\xfb\xc6\xc0\xb7\x02\x03\x01\x00\x01'



priv_s = '''0\x82\x04\xa3\x02\x01\x00\x02\x82\x01\x01\x00\xb85\xa4\x92\xbeV\xa9?\xfe\xf8\xbb\xcfm9\x86\x1f\xe5\x90k\xb1(\xce\x01\xd0\x83u|p\x88\x13\x8f\x98\xc3\xf4\x11\xe1\xe4+\xdb.|\x06T\x16\x9c\x19#\xe5\x8a\xcd\x92\xcf\x0c\x0eO\x80f]\xc6\xa8\r{\xd9\x1d,x\xa9\xf0\x87\xe6\xceo\xfdl,\x1c\xcay2\xdcgab\x0c\x8a\'\x11#\x8dB\x9e)\xd0\xa3\xe5`>T\xd5\xd9\x97\x846F\x02yFl\xe7\x12\x92\x91\xa7\x14Q\x18\xb5gp\x1bU\xd7B#\xf1KY\xc0\xb8V\xd5k\xe7fg\xe0\xf3\xb4\x97E^\x03\xaa\xdf8kJ0\xd2\xbe\xa0\x94x\xc0\xb9\xa5\xe3\xa4\x06z\xd5\xe6\'\x0b\xe0\xd5,\x81\xc2-9\x846\xef\x85?\xc1\xcfU\x1f\xfb\x05\xda\xbb\x03\x82p\xd8\x81\xe0T\xfe\xe8\xc3\xe1=A\xce\xd7\x8fC\xa9\xdc\xcf\xa4\xe2\xf6Q\xd2\x1f\x89\x9aK\xdc\xa5F\xa7C\x10\xef\x12\xd7\xde\xb2=\xa1+\xda\x98*N\x071\xdf\xbe\xcd\xa1\xdc\xc0\xd7\x08x\xe9\x02\xcf\xfc#\x8f\x80\xd4hY\xfb\xc6\xc0\xb7\x02\x03\x01\x00\x01\x02\x82\x01\x003\xfa\x0e\xe1\xc9\x0b2\xdew\xd7?G\x1c\x0e\xab%\xbc\xe4\xaf>a\xc1\x1f\t\xf2\xcd\xe7\xba\xe8\xea|\x0e"\xdco_I\xbe\x86-\xeb\x98\xed\x89#\xaa\x84Rt\x83\xe4\xf4\xbe\xf6\x1a\xc0\xa4!\xb9\xb8\x19u\xe4\xa12\xb7)\\Q<r\xebn\x9ac(\x0c\x89~,j\x8f3\xd7M\xf4\x10\x05\xf4\t\xe4\x0e\xf0l\x0e\x80\xc5\x95\xb2q\x9f+\x13\x15V\x05Z5\xc8M\x99E\xb7\xdb\'\xb6\xcd\x18\xce\xad\'\xdf\x81.\x1b\x1b\xa3\xcb\x1d\xe9ln\xf4d\x86\xc8x\xcc\x1dm\xf0\xb3Z\xcb\xa7s\x82\x13\xb1s\xbc\x10\xf3\xcdOo>b\x95w#U\x92;\xcf\x12~)IV>\x80\xe6W\x06\xec\x87n\xce\xa6rYCv?\x95\xb9/P?"\xcb\x001\xe2\xa77\\\xf8\x0f\x03\xbf\x0b\xa5L\'\x8b\x1f\x81W_\x0b\x9e#\xfa\xca\x1fg\x8fXr\x03h\x19A\xb3\xc5\xa3s\xdf\xc5\xc6T\xe5)A\xbd\xa7\xe6a\x15\x19Y\xd0\x8e\x9e\x12\x83\x89]\x05\xb7\'7\xe7\xc1\x02\x81\x81\x00\xc2H\xd0\xc7\xc9\xd3\xf6Z,\x8b\xddM\xcd\xbdHK(\xfe#Us\xda-\xa8\x95\x94\xa1\xc9\xc3\xdb\xd2\xce\xa0V\x02H\x8a\xd5\xd9\x11\x81[\xad\xf5\x80\xb4~q\x88\xb3\x1f\xed(x\x17\xd5\xe81]h\x9b\xac\xd7\xcc\xbc\xc90\xd3\xc8\xc8ai 5\xdd\xbe\xc9]5\xc4\xf7X\x16znW}\xf9]\xfe\xc3\xbc-\xf4(\x81\x8d4\xce\xb7 \xff\x98\xb70\x16\x80\xab\x044\x0ei\x80\xf3RL\x13`\xbbtw&\x19B\x95\xf9\xc2\xb9\x02\x81\x81\x00\xf2\xb9\x89\xd0<\xfa\x1e\x0f\xe4\x9cQ\xb8\xe7\x95w\xcd\x02\xa5r\x82\xb8\xa9\xe5m\x94\x02v(\x04\xbb\xcc\xc2\xf5\x18\xadi\x000m?\x16=\xceZ\x17\xf8\x0fsC\xa4\x03\xbb$\x83a\x8dKp/\xaa\x06\x02\r]\x1a\x06\x7f\xff\xad\x92\xe6\xba(\xcb\xc6M)\xfaE\x93)4\xc1T\x11[c>\x86\xa7\x9bUQ\x97\xdf\xa880t\xf5\xed\x12Q\xfe\xd8_U\xd9\xde&\x02\xc3\x88\xd10\xe8X\xd6\xf9\x8d\xe3LN\xb3\x8b\x06\xa6\xef\x02\x81\x80-?F\x18q\x81\xc2\xeb\x07Z\xdf\x84\x828\xe6\x00S \xb4\xdb\xee\xeaN\x1d\xe8\x10@\x89\xbb\xea\x932\xfa\x16m\xdb\xb51\xce\xa7\x0c\x08m\x003$V\x1a\\\xea\xd2\xb1\xa9\xee&&\xf47\xa2\xf8|\xe1\t5.vp\xbf\xb2\x100\xd7\x89\xdf\xe1\xaf\xd07\xbc\x11\x0eE\xde\x9eN\xdac\x85S\x05\xc5R+%\xa4\xd5_,\x80D\x18\x14N\xdd\xc2\xfeJ\xa3\t\x8c\x92\x1a\xb2$x\xf3,\xc4\'\x84\x1dG\xab4]\xb7XI\x02\x81\x81\x00\xa4]\xf8qG\x99\xa8\x99\xe2\x99\xe8\xcdj%\xd1\x86\xc6\xef\xfa\xe7\x82\xdd\xaa;\xd6+\x04\x90}\x04\x1f\xd95\xd8\x8c5\xba\xa7\x10\x93\xd4\x1f\xee\x89\x1c\n#\x8cN\x95\xd6\xe0\xf8\x0c\xf0\x16\x9a\xabQ\xdb\xb5M\xd6v\xe1\x94\xdd@\xea\xed\xbb\xc8\xfc\xafa\x8e\x07\x8b/jDQ1J\x18\xa6\xe6B\x055\xa2\xfe\xd7\xce\x1c\xea\xf1\x81\xfe\xf2:\xa4YZVs\xd8\xd3<\x98H\xee\xd8\xcb\xb0n\xe7\x1aL\xccD\xcb\xfb\xcf\xa1\xa9\xd3\x89\x02\x81\x80\x1c\x83\xd6\xe0\x93\xd9}\xba\x1a\xa4D\xf2\x02\xf8\x1a$\x80\x7f\t\x94K\x1ckv~\xaf?>\xf4@\x9bm\xf3\x91\x04\x8e@\xa3\x8a\xe1Eh\xf9Mk\x02\x91\xd14\xe1\x1d\x1a\xf0\\\xb1*hh@\xaa\xe0\xb5\x0e0\x7f\x11\x0b$\x8e\xda\x0f\xde\xde\xf9\xd8\x7fTYs\x8dR]\xb3\xd2\xc2\xfa\x04\\\xc0\x8d&\xb7\xbc\'\xf5l\xf7\x9b\x0c\x1f9^1\xfd|\xec\x84\x06\x9c\x0c\xa4\x87\xd3+\xf8\x17`c}E4\xc1\xe8\xd1\xa0\xadb\xfe'''



password="kitty"

message = hashlib.sha256(password).hexdigest() 
h = SHA.new(message)

key = RSA.importKey(pub_s)

cipher = PKCS1_v1_5.new(key)
ciphertext = cipher.encrypt(message+h.digest()).encode("hex")


p=KNode()
p.name="parent directory"
p.q=1
p.secret="psecret"
p.writers=[pub_s]
p.readers=[pub_s]
p.readers_keys =[ciphertext]
p.ws=['234234234','362345rg','2oi5gm']
p.key = message
p.contents = []

push(p.to_cipher(),p.to_text(),p.getKey(),"",priv_s)
 
shell.shell(p,priv_s).run()

