import KNode
import hashlib
import sys
from KNode import *
import shell
from connect import push, set_hostname, set_port
from Crypto.Cipher import PKCS1_v1_5
from Crypto.Hash import SHA
from Crypto.PublicKey import RSA
 
set_hostname("httpd@172.16.117.128")
set_port("22")

## RSA KEYS FOR TESTING:

pub_s = '0\x82\x01"0\r\x06\t*\x86H\x86\xf7\r\x01\x01\x01\x05\x00\x03\x82\x01\x0f\x000\x82\x01\n\x02\x82\x01\x01\x00\x86\xff\n\x0f\xf1U}\xb8\x00-\xe5\xbd\xd5\xc08\x05o/qN\xa6\xb7v\xa3\x1cd\xf5e0\x9f\xb2\xcbT\x9d4\xde\x87\x1f\x9d\xf3\xc1\xbf\xce\x04j=\xa4\x18\xb2Fu\xb5:B\x88\xed\x1a\x9b\x1b>\xb4f\xa3I@\x89.7\x1fz\xbe=\x02%N\xee63\xac\x01\x19)]\xe0\x8c\n\tL_\x04\xa6R\xbb6~\x0b\xca\xcf.\xfcT\xd3\xd4\x94+\xff\xf4b@\x9b\xfb=\xde\x87"\x1d\xb4\xb5~\xfd\x8d*\xf4\xed}\xa9;Z\xa2\x02\xb9\xf5\x8d\x00O\xe8\xa5\xb4d5\xedh; \x16T\xea\x89\x00]W\xbe\xd2\xd4\xdaSa\xa6\xe0\xacb\xdd\xce\x03\xe0\xc0Yh\x9a\xf9\xe7M\x01R\x0e\x9c9\r\x92#\xb1\xa3&\\5\xee\xcf<\xd5\xf5\x16\xe2\\\xbd1\x1b&t\x16g\x15\xbf\xcf\'/\xcfE\xe3\x9dfl\xb5\xc9\xd5\'\xa2\x9f\xcfI,\xc0h\xce{\xbb%\x181a\xd6N\xdf\xa3\xa90Z\x18.\x9a\x13m\xc6I\xde\xb1<|L.\x9a\xc0\xebprWk\x02\x03\x01\x00\x01' 



priv_s = '0\x82\x04\xa5\x02\x01\x00\x02\x82\x01\x01\x00\x86\xff\n\x0f\xf1U}\xb8\x00-\xe5\xbd\xd5\xc08\x05o/qN\xa6\xb7v\xa3\x1cd\xf5e0\x9f\xb2\xcbT\x9d4\xde\x87\x1f\x9d\xf3\xc1\xbf\xce\x04j=\xa4\x18\xb2Fu\xb5:B\x88\xed\x1a\x9b\x1b>\xb4f\xa3I@\x89.7\x1fz\xbe=\x02%N\xee63\xac\x01\x19)]\xe0\x8c\n\tL_\x04\xa6R\xbb6~\x0b\xca\xcf.\xfcT\xd3\xd4\x94+\xff\xf4b@\x9b\xfb=\xde\x87"\x1d\xb4\xb5~\xfd\x8d*\xf4\xed}\xa9;Z\xa2\x02\xb9\xf5\x8d\x00O\xe8\xa5\xb4d5\xedh; \x16T\xea\x89\x00]W\xbe\xd2\xd4\xdaSa\xa6\xe0\xacb\xdd\xce\x03\xe0\xc0Yh\x9a\xf9\xe7M\x01R\x0e\x9c9\r\x92#\xb1\xa3&\\5\xee\xcf<\xd5\xf5\x16\xe2\\\xbd1\x1b&t\x16g\x15\xbf\xcf\'/\xcfE\xe3\x9dfl\xb5\xc9\xd5\'\xa2\x9f\xcfI,\xc0h\xce{\xbb%\x181a\xd6N\xdf\xa3\xa90Z\x18.\x9a\x13m\xc6I\xde\xb1<|L.\x9a\xc0\xebprWk\x02\x03\x01\x00\x01\x02\x82\x01\x00\x02~\x0e\xf7\x80c-\xb1\t\xff\xce\xf0\x14T:4\x8fz\xf6\xc2\x96\xfdh)V\xca\xdee\x01\xe2\xd0\xf0D\x1d\xaa\xee8\xdcr\x94\x1f\x8d\xa5\x06\x1b\xd8\x0b\x81\x919\x0f\xcfJ\xc6\x13\xb5\x1c\xfa\xa4$"<\x8a\xe3=W\xcb\x0c\xa5~$\xa9\x07\xb3\x1c\xa3\xf5H:\xf2\xc2>+G\x8c\x0e[a\x97\x97\x84b\x9e\xa6@\xe9\x82\xd3\x14q\x007\xf1\x02\xd3U$s\xf3\xf1mP\x15\x1d\xb5\x99\x8a\xce\x97\x0b\xa3a\x99\xa8\x10\xdb\xe1\x06\xa2}\x99\xa3\x93\x83\x12\xc8uv\x89HP\x1e\xb7\xc1\x12\x8cy\xce\x19\x0f\xcc\xf5\xde\n\x01D\xcb\t\xdb\xaa\xe0T\xbf^k\x98mU\xb7\x025\x8f\x17\x0c&U&,\x9e!o\xad\xd2\x19\x8c\x13\xe1>\xf2\xe0\xd5\x81\x98\xea\xd7\x87\xd4\x83\x9e\xca\x83\xaa"\xa6\x06\x9f\xc6\x963\x84\x80\x7fUm\xe4\xb1_pX\x98\xa3if\xdd\xcf\'\xc6\xbc\x9ar\x88\x98\xa0\x9e\xcc\xf4\xbd\x0ertL\xa7\xcf\xd9\xe7\x98\xf6\xd4\xefRZ&\xfc\xc1\x90\xa1\x02\x81\x81\x00\xb7H;|^#\x9c@=:\xd3\x16\x1b\xd6\x960\x1b\x80Od:\x87\x15\x97\x88:\xd2\xf9$\xd8\xfb\tb\x8f]]^\xbb[@}\x19\xb3}<\\L[J\xf8dO\xea\xd2\x9fC\xb9rU\xed\x86\xd6?\x05jj\xbf\\z=\xfc\xa1wq\xdc\xdd0<\x11\xadA~2\xa5\x9feW\xc8\xca<\xc4iC\xf86\x92\x98{*\xd9\\\xa6\xc8\xcefS\xbcRx\x04\x9d\xb48\xc2\x00\x85t\xd3-\xb9t\x15\x96J\xa0\x9f\xab\t\x02\x81\x81\x00\xbc\x8eu\xc2\xfd7\x9dT\x93\x00d\x17{t\r\x13\tP\x16\x94Lj\xc6\xaa\xad8n\x01\xbctw\n\xab\xc2\x05YJ\xd4\xfb*(\xe4\xbc\xa2]s\x90\x0cZt\xbe\x87\xa6\xd0&\xc0\xdb\xd0f\x17\xd9\xf4\xde\xf7\x17w)\xab2\xe2\xe3\x94\xdc^a\xf6\xcb%\xc7\x0c\x05\xdc`.9i\x04\rm\xf6_Q\xa8\xdcot\xc4d!\xbb\xa1\x81\xd0\xb7\xb3\x16~\xb4\xaf\xfe\x15-\xe3S\xba\xcfh\xa8C\x97\xc6\x18\x87\xdb\xdb\xfa\'\xd3\x02\x81\x81\x00\x91\xda(\x84s\x01\xd1\xa1\tX\xdb\x8c7\x81\x0f\xa9\x9e\xe8\xff\xc4\xda\x12\x8f\xab3\xdc\xe3\xf1"R\x8d\x8bMd\x9b>\xe7Y\x1fg\xf5e\xd3\x810\xdc\x9eb\xf4\t1\x02\xab\xf3\n\x8c\xc1q\xecQ\x86@\xce\x8c\x07\xc0\x85"\x19\xa1d~5\xe8e\x83\x9b\x93\xe1\xd9GJ\x1f\x11\xd0\x03\xbc\xd4\xeb\xa3j\x05\xfe\xf1\xf2\xb3\xbc&\x1f\xd63\xb6\x02\x0c\xc6?\x92\x98\xea+z8f\x06t\x95\xbf\x7f"^\xf7\xb3\n\x13\xbf8\xf0\xc9\x02\x81\x81\x00\x87\xabmZ.~<\xaa\xe4\xd6\xac.%:\xdcIm2\xfd\xfc\x18{\xdf\x94`\xec\xb0byi\xc7Y\x9b:\x10E.M\xce\xa6\x88$\x05\x02B\x81k\r(l\xc5\xc6\xaf%(-.<e\xa9\x15\xbfVJ\xad\xcc\xa4\xe3\xb4\xca\x81\xfb\xd3\x0f\xea&\xfc\x06\xa3\x90\xa8\n\xe7\xfdz{pZ\x05[\xf7;\xb7g\\\x9e\xc4\xccSeA\x119\xcfc\x81u\x0b\xa7r\x07e,#K\xcf\xfe\xba\xcb_\xc2>VJ\xc0\x9d\xde\xd7\x02\x81\x81\x00\xa9?5\xf0\xf9\xe5+_\xe7\xd30\xc5]\xe4\xcb\xd5\xed&y\xa7Jt\xf2\x80\xa5\xbf\xfb\x13\xd8\x0f\xe3)\xf0\xdcJ\x12Jl\xaf\x8d\xc1j\x9dx9\xfc\n\x9c\x97\'\xb2\x8cp\xe5\x04\x15G@R\xdc\x10\xddYP\t\x89]h\xa5\xf2\t\xbe\xf5\xee\xd7\x9c\x0c\x13\xb0\xac\x17\xfa\xf9\xd9Y\xc8\xf6\xe1db\'\xe6\xfd\x14\x95mh]\xabn\x8e)\xa8\x8c\x12\xc1\x87e\x8e\x07\xdb\x85\x1e2\x08I\x03\x9e\x15V\xfc=\x08\xfe\x0c\xf16D' 



password="kitty"

message = hashlib.sha256(password).hexdigest() 
h = SHA.new(message)

key = RSA.importKey(pub_s)

cipher = PKCS1_v1_5.new(key)
ciphertext = cipher.encrypt(message+h.digest()).encode("hex")


p=KNode()
p.name="kbox1"
p.q=1
p.secret="psecret"
p.writers=[pub_s]
p.readers=[pub_s]
p.readers_keys =[ciphertext]
p.ws=['234234234','362345rg','2oi5gm']
p.key = message
p.contents = []

if len(sys.argv)>1:
    push(p.to_cipher(),p.to_text(),p.getKey(),"",priv_s)
 
shell.shell(p,priv_s).run()


