import KNode
import hashlib
from KNode import *
import shell
import sys
from connect import push, set_hostname, set_port
from Crypto.Cipher import PKCS1_v1_5
from Crypto.Hash import SHA
from Crypto.PublicKey import RSA
 
set_hostname("httpd@172.16.117.128")
set_port("22")

## RSA KEYS FOR TESTING:

pub_s = '0\x82\x01"0\r\x06\t*\x86H\x86\xf7\r\x01\x01\x01\x05\x00\x03\x82\x01\x0f\x000\x82\x01\n\x02\x82\x01\x01\x00\xa8\xa6\xbb\x19\xf0\x91}c$0*\x14r`\xb7>\x98\xd4\x8b\xd5s!o\x9b\xd6\x9da\xecR\xb42b4$We\xda6"e\xd8\x01\x0eO[1Vq\x8bm\x94\xd9"\x83\t\x93\xdbt\xb1\xd7\xd9\xe2\x01\xe40L`\xff;@Y\x18w\xa5\x02\xadg\x8c\xa0\x16bv+#\xff\xa1L\xc4\xde\xccQ\x93[\xf2\xf4\xf9\x10V\t(\x98\x93#@\xd2\x93T\xacX\xd5\xcc\x91u~\x9e\xe9\xe5\x1b\xcc\x8f\xd0\xe4?\xebK\xcd\x0c\xd5\xee\x05\x10\xc1q\xc7\x9e\rw~+\xcfZH\x15S\x9b<\xf8\x98d]\x02\x14\x00W\xd8\xe3\n\xfa\x98\x93\xf3\xd2,\x1c\xa3\xdbD\x15\x91\xa0V\xad\x93\xe4P\xb5\xf2+Zs\xa8\xca]~\xaeqN\x86\xa5I(\xcc\xba\x11\x01|L\xaa\xea_\xba\xe5-\x98\xff\xbfX\xc0\x83/c\x1b\x19\xc0\xce\xe6/dL\x99\xe9\x91q\x89\xc3\xc9\xca\xe8\x80\x0fHe\xfe[\x08\xd0\'F\x8f\x08\x8a0\xb4\x0cY\xf6\xac\x07\xf1\xe2\x9d\xfa\xcd\xb4\x05\x19\x02\x03\x01\x00\x01' 



priv_s = '0\x82\x04\xa2\x02\x01\x00\x02\x82\x01\x01\x00\xa8\xa6\xbb\x19\xf0\x91}c$0*\x14r`\xb7>\x98\xd4\x8b\xd5s!o\x9b\xd6\x9da\xecR\xb42b4$We\xda6"e\xd8\x01\x0eO[1Vq\x8bm\x94\xd9"\x83\t\x93\xdbt\xb1\xd7\xd9\xe2\x01\xe40L`\xff;@Y\x18w\xa5\x02\xadg\x8c\xa0\x16bv+#\xff\xa1L\xc4\xde\xccQ\x93[\xf2\xf4\xf9\x10V\t(\x98\x93#@\xd2\x93T\xacX\xd5\xcc\x91u~\x9e\xe9\xe5\x1b\xcc\x8f\xd0\xe4?\xebK\xcd\x0c\xd5\xee\x05\x10\xc1q\xc7\x9e\rw~+\xcfZH\x15S\x9b<\xf8\x98d]\x02\x14\x00W\xd8\xe3\n\xfa\x98\x93\xf3\xd2,\x1c\xa3\xdbD\x15\x91\xa0V\xad\x93\xe4P\xb5\xf2+Zs\xa8\xca]~\xaeqN\x86\xa5I(\xcc\xba\x11\x01|L\xaa\xea_\xba\xe5-\x98\xff\xbfX\xc0\x83/c\x1b\x19\xc0\xce\xe6/dL\x99\xe9\x91q\x89\xc3\xc9\xca\xe8\x80\x0fHe\xfe[\x08\xd0\'F\x8f\x08\x8a0\xb4\x0cY\xf6\xac\x07\xf1\xe2\x9d\xfa\xcd\xb4\x05\x19\x02\x03\x01\x00\x01\x02\x82\x01\x00o\xe1K\xb5\xc5\x95~\xac\xcaP\xf9Y_\x171\xf8\xe0\xc1\xff\x91\xb62\xb4+\x99\x90\x06j\x13\xe3^\x99/%\xfc\xa4\xa0\xc1\xd0\xc7\xe7\'\xac*\x90\xc0\x86,\x04\xe6\xc9\x1b\xd2}CYF\xf8\x7f\x12F\x84[\xe4\xd8\xf5\x92S?\'L\xf3\xa2Ka\x1fO\xd6FM\x13<y\x1a\x04w(\xcaaS\x01\xba\xd4\x00\xb4\xea\x95\x1f\xbe+\xa4+\xd7\xf3$\xbe\x80)e5O\xe4\x1f!\xc4\xa2=N\xd7\xc1\x80>*\xf9\x18\xec\nZ\xbcr\xd4\xcf2\xa2\x8f\x9cv\xd7\x9b\'\x996P\xcb\xab\x1b\xd4d\xb9\x08\x01T6\x18tm-a\xa6\x92\xab\'\x1f\xc13\x17\xf35T\x13\xc9\x84\x86}w\x03k\xa1\xba\xb6+\xd2\x12\xcd\x98\x94\xf0\xde\xaf\xb7\xd6qU\x12T:\x85\xd9\xbb\xac\xa1\xb3\xb3\xa9\\\x80\x9c]\xd8U\x80\xac\xfd\x1d\xe1\xea\xcc\xd3\xf0B:a\xc8\x06\xc2$)L\xc0r4x\xae\xbby\xe9\xc8\x13\xaa\xb6\xa3\xe5\x01\xa6?\x8e\x98\xa0\xc5m-|\xb5Z\x1d\xd1\x02\x81\x81\x00\xc0\x87lW\x07CbB\x99\x99\x88\n3\xb5a\x8c\x0e\x03^\xab\xcd\x90\xbf8\x05&\xccW\xba\xef\xcd\xa1S#Ro\x81\xd9\xc2 \xc20\xda\x01\xc0\x8ag\x97q\xf7*\xdc\xea\x99\xa0\x07\x8b\x16\xa7\xb8\x96\xc1\x91J\x0cY\xa7\xae\nPZXk\x8a\xbbob\xa2\xf0+U\x12h\xde[w\x14H\xf3(\x16\xd8{\x11\xb6)Z\x8a\x97\xff9Gy\x91+F\xe7;;z\x1e$>\xd3\x8co\x88\xedd\x9c\xe6_u8\xfe<\xec\x0b\x02\x81\x81\x00\xe0@#*\xcdU\xe4"\x11\xe5\xf2kD\xf8\x10B\xe6\x84\xab\x17ZsC`N~\xd4\x98}\xe8=\x8eM\xe8\x0bA\x01\xbb0\r\xe0\x08\xb0\xfb\'\x1eI\xde\xde2\xb00\xa5\xf9\xea\x92^\x87F\xc1\xce<\xf0^\xb1.7]\xa9\x9c\x0e\x1e\\H5-O\x83\xd9cbm\xc2T\xaf\xb7\x17\x9f2\x95\xf7\x05E\xde\x9d\x1b\x87Z\xb0S\xa7\xf7\x9d\x96\x8d\xf2\xf0\xdd\xc2n<6\x92\xf1\xb8)\xc0\x7f5yl\x84?\xc1\xe9Ue\xeb\x02\x81\x80\x10\xce\x81\x95\xa3K\xad\x934\xc7cI\xc8\xb3\xc7\xbd+\'\xfe&\xaf>8\x83\x12h\r\xa4\x86\xec\x12\x1eH\x1c\xa8@\x95\xacE\xb7\x08\\\xad[C\xcc\x918v9fc|\x93F\x96\x01\xfdKL\xe0\xd4*\xf3\xb4\xdaJ\xb9\xf5\xaa\x88\x08y\xf2\xd5c\xe6\xcfdy\xd3\xe6T\x83<\xa6\xcb}\x86\xc4t"\x17\xb47\x1b\xab\x0c\xb82\x0et\xff\xd6\xbdYf,\x14\x88\x17\x83\x80|\x85 \xe3j\x1d\xc3X\x94\xf2\xad\xb3\xfb\xeb{\x02\x81\x80@\xa6|\xfd\x04\x01\xb5)\x95[c\xceE-\xf7\x122\x7f!\x0c4\x89rm;t\x19:ub\x15\r\x07\xac\xd4A\xc3\x8c\x01\xc8\x9eD#1\xe5\x0f8`\xc6Rz\xb5+\xc4\xa79\xd7\x82\xcc\x85g=\xeeV~bB\x98\x00#\xfbv\tH\xcf\xfb\xe6&\xae\xef\x96\x1a\xea\xa1\x9b\x9e\xffrh\x15\x10\x087"|\xcc\xc8\xf2\xfeN\xbf\xe8\x05H\xb8W\xc7\xd5G\x0e\x9c\xd1f\xff\xc5\x06Tv\xd8%\xcf\x819\x18`z\xbcM\x02\x81\x80\x12r\xbc\x92\x9d4\x99\xc1\xd2_\xf2.\x0enZ.\x8f\xf8\x7f\xa0\xee\xe7\x11\xfe\xfb\x02\tC\x82\xcc\xb6\x93Mg:\x870\x04\xbdbj\x9e\x8b\xefX1\x97\xb8\xc2\x8dU\x04\xcf\xf3\xe7\x00i-33J\x0e\xea\x00P\xe1\xferE\xc7\xa5\x95+\x118lx+\x02\xc6$\xc9\xa55\x14\\\x9c\x04\x13\x15\xac2!\xeb\xda\x0f*o\xa1G\x99\xdbf\xbd\x0e\x0e\x1d\x04\xb3\r\xf0z[\x85\xf6v\xe1\xc0,\xa7FN\xb1|\xa3\xf8\x8cz' 



password="kitty"

message = hashlib.sha256(password).hexdigest() 
h = SHA.new(message)

key = RSA.importKey(pub_s)

cipher = PKCS1_v1_5.new(key)
ciphertext = cipher.encrypt(message+h.digest()).encode("hex")


p=KNode()
p.name="kbox2"
p.q=1
p.secret="psecret"
p.writers=[pub_s]
p.readers=[pub_s]
p.readers_keys =[ciphertext]
p.ws=['234234234','362345rg','2oi5gm']
p.key = message
p.contents = []

if len(sys.argv)>1:
    push(p.to_cipher(),p.to_text(),p.getKey(),"",priv_s)
 
shell.shell(p,priv_s).run()

